<template>
  <div class="product">
    <div class="row">
      <!-- ***************************GALLERY**************************** -->
      <div class="col s1 gallery">
        <template v-for="(imageInfo,index) in getImages">
          <div :key="index" class="row abs">
            <div v-if="imageInfo.color == selectedColor">
              <template v-for="(image,key) in imageInfo.images">
                <div :key="key" class="img-content" @click="setMainImage(image.url)">
                  <div v-if="imageUrl == image.url" class="img-cover"></div>
                  <img :src="image.url" class="img-gallery" />
                </div>
              </template>
            </div>
          </div>
        </template>
      </div>
      <!-- ***************************GALLERY**************************** -->
      <div class="col s7">
        <!-- <zoom-on-hover :img-normal="imageUrl" scale="2" class="main-image"></zoom-on-hover> -->
        <img :src="imageUrl" class="main-image" />
      </div>

      <div class="col s4 variants">
        <div class="row b-bottom">
          <p class="product-name right">Bicicleta Optimus Tucana</p>
          <p class="right "><b>SKU: </b> BITCN0919</p>
        </div>
        <div class="row">
          <h6 class="left">Rating:</h6>
            <div class="review row col s5" tooltip="4">
              <i class="small material-icons center orange-text" style="margin-right:3px;">star</i>
              <i class="small material-icons center orange-text" style="margin-right:3px;">star</i>
              <i class="small material-icons center orange-text" style="margin-right:3px;">star</i>
              <i class="small material-icons center orange-text" style="margin-right:3px;">star</i>
              <i class="small material-icons center orange-text" style="margin-right:3px;">star_border</i>
            </div>
        </div>
        <div>
          <!-- COLORES -->
          <div>
            <div class="row mb-0">
              <h6 class="left mb-0">Color:</h6>
            </div>
            <div class="row mb-5">
              <template v-for="(color, index) in colors">
                <div :key="index" class="col xs1 color-select" @click="setSelected(color,'color')">
                  <div :class="{'panel-cover':color.selected}"></div>
                  <img :src="color.url" />
                </div>
              </template>
            </div>
          </div>

          <!-- TALLA -->
          <div>
            <div class="row mb-0">
              <h6 class="left mb-0 mt-3">Talla:</h6>
            </div>
            <div class="row">
              <div class="col xs1">
                <template v-for="(size, index) in sizes">
                  <a
                    :key="index"
                    :class="[{black:size.selected},
                    'waves-effect waves-light btn black-text mr-6',
                    {white:!size.selected},
                    {'black-text':!size.selected},
                    {'white-text':size.selected}]"
                    @click="setSelected(size, 'size')"
                  >{{size.value}}</a>
                </template>
              </div>
            </div>
          </div>

          <!-- VELOCIDADES -->
          <div class="">
            <div class="row mb-0">
              <h6 class="left mb-0 mt-3">Velocidades:</h6>
            </div>
            <div class="row">
              <div class="col xs1">
                <template v-for="(speed, index) in speeds">
                  <a
                    :key="index"
                    :class="[{black:speed.selected},
                    'waves-effect waves-light btn black-text mr-6',
                    {white:!speed.selected},
                    {'black-text':!speed.selected},
                    {'white-text':speed.selected}]"
                    @click="setSelected(speed, 'speed')"
                  >{{speed.value}}</a>
                </template>
              </div>
            </div>
          </div>

          <!-- RINS -->
          <div class="">
            <div class="row mb-0">
              <h6 class="left mb-0 mt-3">Rin:</h6>
            </div>
            <div class="row">
              <div class="col xs1">
                <template v-for="(rin, index) in rins">
                  <a
                    :key="index"
                    :class="[{black:rin.selected},
                    'waves-effect waves-light btn black-text mr-6',
                    {white:!rin.selected},
                    {'black-text':!rin.selected},
                    {'white-text':rin.selected}]"
                    @click="setSelected(rin, 'rin')"
                  >{{rin.display}}</a>
                </template>
              </div>
            </div>
          <div class="row">
            <a class="waves-effect waves-light btn black left" style="width:100%; font-size:25px;">Añadir al Carrito</a>
          </div>
          </div>
        </div>
      </div>
    </div>
    <div class="black">
      <div class="border-middle">
        <img
          src="https://cdn.shopify.com/s/files/1/2568/3124/files/Tucana_1280x_82e6ee99-a300-47ef-8c71-98f590b47227_1512x.jpg?v=1570291450"
          width="100%"
        />
      </div>

      <ficha-tecnica></ficha-tecnica>

      <div class="border-middle">
        <video
          class="valign-wrapper responsive-video"
          id="videoBG"
          poster="@/assets/img/corvus-img.jpg"
          autoplay
          muted
          loop
        >
          <source src="@/assets/videos/tucana.mp4" type="video/mp4" />
        </video>
      </div>
    </div>
    <footer-contact></footer-contact>
  </div>
</template>
<script>
import { bikeImages } from "@/helpers/dbBikes";
import fichaTecnica from './fichaTecnica.vue';
import footerContact from '@/components/footerContact.vue';
export default {
  components:{
    fichaTecnica,
    footerContact
  },
  data() {
    return {
      dataImage: ["1", "2", "3", "4"],
      rins: [
        { value: "27", display: '27.5"', selected: false },
        { value: "29", display: '29"', selected: false }
      ],
      sizes: [
        { value: "XS", selected: false },
        { value: "S", selected: false },
        { value: "M", selected: false },
        { value: "L", selected: false }
      ],
      speeds: [
        { value: "8", selected: false },
        { value: "9", selected: false },
        { value: "10", selected: false }
      ],
      colors: [
        {
          value: "amarillo",
          selected: false,
          url: "./media/img/colorSelect/amarillo.png"
        },
        {
          value: "azul_naranja",
          selected: false,
          url: "./media/img/colorSelect/azul_naranja.png"
        },
        {
          value: "azul",
          selected: false,
          url: "./media/img/colorSelect/azul.png"
        },
        {
          value: "blanco",
          selected: false,
          url: "./media/img/colorSelect/blanco.png"
        },
        {
          value: "morado",
          selected: false,
          url: "./media/img/colorSelect/morado.png"
        },
        {
          value: "naranja",
          selected: false,
          url: "./media/img/colorSelect/naranja.png"
        },
        {
          value: "rojo",
          selected: false,
          url: "./media/img/colorSelect/rojo.png"
        },
        {
          value: "verde",
          selected: false,
          url: "./media/img/colorSelect/verde.png"
        }
      ],
      selectedColor: "azul_naranja",
      imageUrl:
        "https://cdn.shopify.com/s/files/1/2568/3124/products/6_1000x.jpg?v=1555799304"
    };
  },
  methods: {
    setSelected(obj, variant) {
      var objInfo = [];
      switch (variant) {
        case "color":
          objInfo = this.colors;
          break;
        case "speed":
          objInfo = this.speeds;
          break;
        case "size":
          objInfo = this.sizes;
          break;
        case "rin":
          objInfo = this.rins;
          break;
        default:
          break;
      }
      objInfo.forEach(info => {
        if (info.value == obj.value) {
          info.selected = true;
          if (variant == "color") {
            this.selectedColor = obj.value;
            /**Seleccionar imagen */
            this.changeImageByColor();
          }
        } else {
          info.selected = false;
        }
      });
    },
    changeImageByColor() {
      bikeImages.forEach(bike => {
        if (bike.color == this.selectedColor) {
          var bici = bike.images[0].url;
          this.imageUrl = bici;
          bike.selected = true;
        }
      });
    },
    setMainImage(url) {
      this.imageUrl = url;
    }
  },
  computed: {
    getImages() {
      var images = bikeImages;
      return images;
    }
  }
};
</script>
<style scoped>
.main-image {
  width: 100%;
  max-height: 600px;
  object-fit:cover;
}
.border-middle {
  width: 100%;
}
.review{
  max-height: 50px;
  cursor: pointer;
}
.img-content {
  margin-top: 10px;
  position: relative;
  height: 80px;
  border-radius: 5px solid grey;
  cursor: pointer;
  top: 0;
}

.img-cover {
  border: 2px solid blue;
  border-radius: 10px;
  cursor: pointer;
  height: 100%;
  width: 100%;
  position: absolute;
  top: 0;
  transition: 200ms;
  -webkit-box-shadow: 0px 0px 10px 5px rgba(0, 0, 255, 0.5);
  -moz-box-shadow: 0px 0px 10px 5px rgba(0, 0, 255, 0.5);
  box-shadow: 0px 0px 10px 5px rgba(0, 0, 255, 0.5);
}

.img-gallery {
  /* height: 100%; */
  padding-top: 5px;
  /* border: 1px solid lightslategrey; */
  object-fit: cover;
}
img {
  height: 100%;
  /* margin-right: 5px; */
}
.gallery {
  position: relative;
  width: 100%;
  /* border-bottom: 1px solid lightslategray; */
}

.variants {
  height: 100%;
}

.color-select img {
  width: 40px;
}

.panel-cover {
  border: 2px solid blue;
  border-radius: 50%;
  cursor: pointer;
  height: 40px;
  width: 40px;
  position: absolute;
  top: 0;
  transition: 200ms;
  -webkit-box-shadow: 0px 0px 10px 2px blue;
  -moz-box-shadow: 0px 0px 10px 2px blue;
  box-shadow: 0px 0px 10px 2px blue;
}

.color-select {
  margin: 5px;
  padding: 0px;
  position: relative;
  cursor: pointer;
}

.mb-0 {
  margin-bottom: 0px;
}
.mt-3 {
  margin-top: 3px;
}
.mb-5 {
  margin-bottom: 5px;
}
.mr-6 {
  margin-right: 6px;
  border-radius: 10px;
   border: 1px solid black;
}
.product {
  margin-top: 1rem;
  border-bottom: 1px solid grey;
  border-top: 1px solid grey;
}

.sizes {
  margin-right: 5px;
}

.abs {
  position: absolute;
  margin: auto;
}

@media (min-aspect-ratio: 16/9) {
  #videoBG {
    width: 100%;
    background-color: black;
    height: 85vh;
  }
}

@media (max-aspect-ratio: 16/9) {
  #videoBG {
    width: auto;
    background-color: black;
    height: 85vh;
  }
}

@media (max-width: 767px) {
  #videoBG {
    display: none;
  }
  body {
    background: url("/assets/img/corvus-img.jpg");
    background-size: cover;
  }
}

video {
  margin: 0;
  padding: 0;
}

.product-name{
  margin: 10px;
  margin-bottom: 5px;
  font-size: 30px;
  font-weight: bold;
  
}
p{
  margin: 10px;
  margin-top: 0px;
}

.row{
  padding: 5px;
  margin-bottom: 0px;
}

.b-bottom{
  border-bottom: 1px dotted  grey;
}

</style>